/* yasep/core-js/yasep_config.js
  This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
dim. févr. 19 19:23:01 CET 2012 : moved core from tool/config.js

This file contains various "core profiles" of varying implementations
 */

profiles={
  "YASEP":{
    comment: "profile for the standard, default, baseline YASEP code",
    datapath:16,
    multiplier:8,
    pipelined:0,

    valid_instructions: {
////// GROUP_CTL :
      "NOP":1,
      "CRIT":1,
      "GET":1,
      "PUT":1,
      "IN":1,
      "OUT":1,
      "CALL":1,
      "CALL2":1,

////// GROUP_SMT :
      "HALT":1,
      "IPC":1,
      "IPE":1,
      "IPR":1,

////// GROUP_IE :
      "MOV":1,
      "SB":1,
      "LZB":1,
      "LSB":1,
      "SH":1,
      "SHH":1,
      "LZH":1,
      "LSH":1,

////// GROUP_SHL :
      "SHR":1,
      "SAR":1,
      "SHL":1,
      "ROR":1,
      "ROL":1,

////// GROUP_ROP2 :
      "AND":1,
      "ANDN":1,
      "NAND":1,
      "OR":1,
      "ORN":1,
      "NOR":1,
      "XOR":1,
      "XORN":1,

////// GROUP_ASU :
      "ADD":1,
      "SUB":1,
      "CMPU":1,
      "CMPS":1,
      "UMIN":1,
      "UMAX":1,
      "SMIN":1,
      "SMAX":1,

////// GROUP_MUL :
      "MUL8L":1,
      "MUL8H":1,
      "MULI":1,
      "CRC":1,

////// GROUP_RSV :
      "INV":1
    }
  },

  "YASEP16":{
    comment: "narrow datapath version",
    datapath:16,
    multiplier:8,
    pipelined:0,

    valid_instructions: {
////// GROUP_CTL :
      "NOP":1,
      "CRIT":1,
      "GET":1,
      "PUT":1,
      "IN":1,
      "OUT":1,
      "CALL":1,
      "CALL2":1,

////// GROUP_SMT :
      "HALT":1,
      "IPC":1,
      "IPE":1,
      "IPR":1,

////// GROUP_IE :
      "MOV":1,
      "SB":1,
      "LZB":1,
      "LSB":1,
//      "SH":1,
//      "SHH":1,
//      "LZH":1,
//      "LSH":1,

////// GROUP_SHL :
      "SHR":1,
      "SAR":1,
      "SHL":1,
      "ROR":1,
      "ROL":1,

////// GROUP_ROP2 :
      "AND":1,
      "ANDN":1,
      "NAND":1,
      "OR":1,
      "ORN":1,
      "NOR":1,
      "XOR":1,
      "XORN":1,

////// GROUP_ASU :
      "ADD":1,
      "SUB":1,
      "CMPU":1,
      "CMPS":1,
      "UMIN":1,
      "UMAX":1,
      "SMIN":1,
      "SMAX":1,

////// GROUP_MUL :
      "MUL8L":1,
      "MUL8H":1,
      "MULI":1,
      "CRC":1,

////// GROUP_RSV :
      "INV":1
    }
  },

  "YASEP32":{
    comment: "wide datapath version",
    datapath:32,
    multiplier:8,
    pipelined:0,

    valid_instructions: {
////// GROUP_CTL :
      "NOP":1,
      "CRIT":1,
      "GET":1,
      "PUT":1,
      "IN":1,
      "OUT":1,
      "CALL":1,
      "CALL2":1,

////// GROUP_SMT :
      "HALT":1,
      "IPC":1,
      "IPE":1,
      "IPR":1,

////// GROUP_IE :
      "MOV":1,
      "SB":1,
      "LZB":1,
      "LSB":1,
      "SH":1,
      "SHH":1,
      "LZH":1,
      "LSH":1,

////// GROUP_SHL :
      "SHR":1,
      "SAR":1,
      "SHL":1,
      "ROR":1,
      "ROL":1,

////// GROUP_ROP2 :
      "AND":1,
      "ANDN":1,
      "NAND":1,
      "OR":1,
      "ORN":1,
      "NOR":1,
      "XOR":1,
      "XORN":1,

////// GROUP_ASU :
      "ADD":1,
      "SUB":1,
      "CMPU":1,
      "CMPS":1,
      "UMIN":1,
      "UMAX":1,
      "SMIN":1,
      "SMAX":1,

////// GROUP_MUL :
      "MUL8L":1,
      "MUL8H":1,
      "MULI":1,
      "CRC":1,

////// GROUP_RSV :
      "INV":1
    }
  },

  "empty":{
    comment: "empty profile for the 'auto' option that fills the instructions list during assembly",
    datapath:16,
    multiplier:0,
    pipelined:0,
    PC_length:16,
    valid_instructions: {}
  },

  "microYASEP":{
    comment: "narrow, minimal core with no memory access",
    datapath:16,
    multiplier:0,
    pipelined:0,
    PC_length:10,

    valid_instructions: {
////// GROUP_CTL :
      "NOP":1,
      "GET":1,
      "PUT":1,
      "CALL":1,

////// GROUP_IE :
      "MOV":1,

////// GROUP_ROP2 :
      "AND":1,
      "ANDN":1,
      "NAND":1,
      "OR":1,
      "ORN":1,
      "NOR":1,
      "XOR":1,
      "XORN":1,

////// GROUP_ASU :
      "ADD":1,
      "SUB":1,
      "CMPU":1,
      "CMPS":1,

////// GROUP_RSV :
      "INV":1
    }
  }
};
